From afdf3d736482fcc267824dee4cee883697d50e3b Mon Sep 17 00:00:00 2001
From: David Tolnay <dtolnay@gmail.com>
Date: Nov 28 2020 02:22:40 +0000
Subject: [PATCH 1610/2232] Use standard library's Hash derive


This avoids Clippy derive_hash_xor_eq warnings in generated code:

    error: you are implementing `Hash` explicitly but have derived `PartialEq`
      --> tests/ffi/lib.rs:28:21
       |
    28 |     #[derive(Debug, Hash)]
       |                     ^^^^
       |
       = note: `#[deny(clippy::derive_hash_xor_eq)]` on by default
    note: `PartialEq` implemented here
      --> tests/ffi/lib.rs:16:1
       |
    16 | #[cxx::bridge(namespace = "tests")]
       | ^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^
       = help: for further information visit https://rust-lang.github.io/rust-clippy/master/index.html#derive_hash_xor_eq
       = note: this error originates in a derive macro (in Nightly builds, run with -Z macro-backtrace for more info)

---

diff --git a/macro/src/derive.rs b/macro/src/derive.rs
index f614add..a015ed0 100644
--- a/macro/src/derive.rs
+++ b/macro/src/derive.rs
@@ -16,7 +16,7 @@ pub fn expand_struct(strct: &Struct, actual_derives: &mut Option<TokenStream>) -
             Trait::Debug => expanded.extend(struct_debug(strct, span)),
             Trait::Default => expanded.extend(struct_default(strct, span)),
             Trait::Eq => traits.push(quote_spanned!(span=> ::std::cmp::Eq)),
-            Trait::Hash => expanded.extend(struct_hash(strct, span)),
+            Trait::Hash => traits.push(quote_spanned!(span=> ::std::hash::Hash)),
             Trait::Ord => expanded.extend(struct_ord(strct, span)),
             Trait::PartialEq => traits.push(quote_spanned!(span=> ::std::cmp::PartialEq)),
             Trait::PartialOrd => expanded.extend(struct_partial_ord(strct, span)),
@@ -57,7 +57,7 @@ pub fn expand_enum(enm: &Enum, actual_derives: &mut Option<TokenStream>) -> Toke
                 traits.push(quote_spanned!(span=> ::std::cmp::Eq));
                 has_eq = true;
             }
-            Trait::Hash => expanded.extend(enum_hash(enm, span)),
+            Trait::Hash => traits.push(quote_spanned!(span=> ::std::hash::Hash)),
             Trait::Ord => expanded.extend(enum_ord(enm, span)),
             Trait::PartialEq => {
                 traits.push(quote_spanned!(span=> ::std::cmp::PartialEq));
@@ -157,21 +157,6 @@ fn struct_default(strct: &Struct, span: Span) -> TokenStream {
     }
 }
 
-fn struct_hash(strct: &Struct, span: Span) -> TokenStream {
-    let ident = &strct.name.rust;
-    let fields = strct.fields.iter().map(|field| &field.ident);
-
-    quote_spanned! {span=>
-        impl ::std::hash::Hash for #ident {
-            fn hash<H: ::std::hash::Hasher>(&self, state: &mut H) {
-                #(
-                    ::std::hash::Hash::hash(&self.#fields, state);
-                )*
-            }
-        }
-    }
-}
-
 fn struct_ord(strct: &Struct, span: Span) -> TokenStream {
     let ident = &strct.name.rust;
     let fields = strct.fields.iter().map(|field| &field.ident);
@@ -263,18 +248,6 @@ fn enum_debug(enm: &Enum, span: Span) -> TokenStream {
     }
 }
 
-fn enum_hash(enm: &Enum, span: Span) -> TokenStream {
-    let ident = &enm.name.rust;
-
-    quote_spanned! {span=>
-        impl ::std::hash::Hash for #ident {
-            fn hash<H: ::std::hash::Hasher>(&self, state: &mut H) {
-                ::std::hash::Hash::hash(&self.repr, state);
-            }
-        }
-    }
-}
-
 fn enum_ord(enm: &Enum, span: Span) -> TokenStream {
     let ident = &enm.name.rust;
 

